EggonsMU.config.enableEvent("OnBeforeFirstInventoryTooltipDisplay")

local function createTooltip(item)
    local foundBooks = EHIFTB.memory.rememberedBooks
    local fullType = item:getFullType()
    local identifier = EHIFTB.getItemIdentifier(item)
    local foundBook = foundBooks[identifier]
    local itemName
    local staticModel = item:getStaticModel()
    if staticModel == "Book" then
        itemName = "book"
    elseif staticModel == "Magazine" then
        itemName = "magazine"
    elseif item:getMap() then
        itemName = "map"
    elseif item:isRecordedMedia() then
        local mediaDataType = item:getMediaData():getMediaType()
        if mediaDataType == 0 then
            itemName = "CD"
        elseif mediaDataType == 1 then
            itemName = "tape"
        end
    else
        itemName = "item"
    end
    if not foundBook then
        return EHIFTB.Options.notFoundPrefix ..
            "Haven't found this " .. itemName .. " yet." .. EHIFTB.Options.notFoundSuffix
    end
    local currentlyInText = ""
    local currentlyOutText = ""
    local currentlyInCount = 0
    local currentlyOutCount = 0
    local output = EHIFTB.Options.foundPrefix .. "Found this " .. itemName .. " already." .. EHIFTB.Options.foundSuffix
    -- output = " "
    return output
end

function EHIFTB.prepareTooltipData(item, self)
    if EHIFTB.isValidEHIFTBItem(item, "showTooltip") then
        -- print("Preparing tooltip data")
        -- local newTooltip = ""
        local newTooltip = createTooltip(item)
        item:setTooltip(newTooltip)
    end
end

Events.OnBeforeFirstInventoryTooltipDisplay.Add(EHIFTB.prepareTooltipData)

local function tooltipRender(self)
    -- print("render")
    self.EHIFTB = self.EHIFTB or {}
    -- print("self.EHIFTB.lastItem", self.EHIFTB.lastItem)
    -- print("self.item", self.item)
    if EHIFTB.isValidEHIFTBItem(self.item, "showTooltip") then
        -- if self.EHIFTB.lastItem ~= self.item then
        -- print("first render")

        -- self.EHIFTB.lastItem = self.item
        -- self.EHIFTB.font = ISToolTip.GetFont()
        -- self.EHIFTB.message = createTooltip(self.item)

        -- print("self.EHIFTB.numberOfTooltipLines", self.EHIFTB.numberOfTooltipLines)
        -- local messageWidth = getTextManager():MeasureStringX(self.EHIFTB.font, self.EHIFTB.message) + 17
        -- print("self.width pre ", self.width)
        -- self.width = math.max(self.width, messageWidth)
        -- print("self.width post ", self.width)

        -- self.EHIFTB.lineHeight = getTextManager():getFontFromEnum(self.EHIFTB.font):getLineHeight()
        -- self.EHIFTB.numberOfTooltipLines = math.floor((self.height / self.EHIFTB.lineHeight) + 0.5)
        -- self.EHIFTB.tooltipStartY = self.EHIFTB.lineHeight * (self.EHIFTB.numberOfTooltipLines - 1) + 10

        self.EHIFTB.blue = 0
        if EHIFTB.isItemMemorized(self.item) then
            -- print("Memorized")
            self.EHIFTB.green = 1
            self.EHIFTB.red = 0
        else
            -- print("Not Memorized")
            self.EHIFTB.green = 0
            self.EHIFTB.red = 1
        end

        -- end

        self:EHIFTB_Store_render()
        -- EggonsMU.printFuckingNormalObject(EHIFTB.Options, "Options")
        -- if EHIFTB.Options.colorTooltipText then
        --     print("Drawing colorText")
        --     EggonsMU.printFuckingNormalObject(self.EHIFTB, "self EHIFTB")
        --     print("self.height", self.height)
        --     self:drawText(
        --         self.EHIFTB.message,
        --         16,
        --         self.EHIFTB.tooltipStartY,
        --         self.EHIFTB.red,
        --         self.EHIFTB.green,
        --         self.EHIFTB.blue,
        --         1,
        --         self.EHIFTB.font
        --     )
        -- end
        -- print("Shoud I draw border? ", EHIFTB.Options.colorTooltipBorder)
        if EHIFTB.Options.colorTooltipBorder then
            -- print("Drawing colorBorder")
            self:drawRectBorder(
                0,
                0,
                self.width,
                self.height,
                self.borderColor.a,
                self.EHIFTB.red,
                self.EHIFTB.green,
                self.EHIFTB.blue
            )
        end
    else
        self:EHIFTB_Store_render()
    end
end

function EHIFTB.initTooltipOverride()
    print("initTooltipOverride")
    ISToolTipInv.EHIFTB_Store_render = ISToolTipInv.render
    ISToolTipInv.render = tooltipRender
end

function EHIFTB.disableTooltipOverride()
    print("disableTooltipOverride")
    ISToolTipInv.render = ISToolTipInv.EHIFTB_Store_render
    ISToolTipInv.EHIFTB_Store_render = nil
end

if EHIFTB.Options.colorTooltipText or EHIFTB.Options.colorTooltipBorder then
    EHIFTB.initTooltipOverride()
end
